﻿function myWidgetModeGetter() {
    if (typeof window.matchMedia != "undefined") {
        var mediamatcher = window.matchMedia("(view-mode: windowed)");
        if (mediamatcher.matches) {
            return "home";
        }

        mediamatcher = window.matchMedia("(view-mode: floating)");
        if (mediamatcher.matches) {
            return "home";
        }

        mediamatcher = window.matchMedia("(view-mode: fullscreen)");
        if (mediamatcher.matches) {
            return "canvas";
        }

        mediamatcher = window.matchMedia("(view-mode: maximized)");
        if (mediamatcher.matches) {
            return "canvas";
        }

        mediamatcher = window.matchMedia("(view-mode: minimized)");
        if (mediamatcher.matches) {
            return "home";
        }
        return "default";
    }
    else {
        if (isMedia("(view-mode: windowed)")) {
            return "home";
        }

        if (isMedia("(view-mode: floating)")) {
            return "home";
        }

        if (isMedia("(view-mode: fullscreen)")) {
            return "canvas";
        }

        if (isMedia("(view-mode: maximized)")) {
            return "canvas";
        }

        if (isMedia("(view-mode: minimized)")) {
            return "home";
        }
        return "default";
    }
}

var isMedia = (function () {
    var div;
    return function (query) {

        //if the div element doesn't exist, create it and make sure it's hidden
        if (!div) {
            div = document.createElement("div");
            div.id = "widgetModeTestObject";
            div.style.cssText = "position:absolute;top:-1000px";
            document.body.insertBefore(div, document.body.firstChild);
        }

        div.innerHTML = "_<style media=\"" + query + "\"> #widgetModeTestObject { width: 1px; }</style>";
        div.removeChild(div.firstChild);
        return div.offsetWidth == 1;
    };
})();

function evalScript(scripts) {
    try {
        if (scripts != '') {
            var script = "";
            scripts = scripts.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function () {
                if (scripts !== null) script += arguments[1] + '\n';
                return '';
            });
            if (script) (window.execScript) ? window.execScript(script) : window.setTimeout(script, 0);
        }
        return false;
    }
    catch (e) {
        alert(e)
    }
}