/*
 This file is part of Universal Web App (UWA) JavaScript Runtime v1.3

 Copyright(C) 2006-2011 Netvibes
 http://www.netvibes.com

 About: License

 Copyright (c) 2011, Netvibes and/or its affiliates. All rights reserved.
 NETVIBES PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 - Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 - Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.

 - Neither the name of Netvibes nor the names of its
 contributors may be used to endorse or promote products derived
 from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(o,j,m){j("UWA/Controls/Ellipsis",["UWA/Core","UWA/Controls/Abstract"],function(l,j){var n=j.extend({defaultOptions:{reference:null,refreshOn:[],ellipsis:"&#8230;",spaces:/[\s,.:]+/g},init:function(a,d){this._parent(d);this.element=a;this.ellipsis=l.createElement("span",{html:this.options.ellipsis})},destroy:function(){this.ellipsis.destroy()},onRefresh:function(){var a,d,b,h,g,c=this.element,e=this.options.reference||c;if(c.offsetWidth){this.dispatchEvent("onPreRefresh");if(!this.totalWords)this.totalWords=
this.computeData(c);a=Math.floor(this.totalWords/2);d=Math.ceil(a/2)||1;c.appendChild(this.ellipsis);for(g=10;0<g;g-=1){this.setWordCount(c,a);b=e.offsetHeight+1<e.scrollHeight;if(a>=this.totalWords&&!b){c.removeChild(this.ellipsis);break}if(1===d){if(h!==m&&h!==b)break;h=b}a+=b?-d:d;d=Math.ceil(d/2)}b&&this.setWordCount(c,a-1);this.dispatchEvent("onPostRefresh")}return this},setWordCount:function(a,d){var b,h,g,c,e,i,f=d;if(a===this.ellipsis)return 0;if(a!==this.element)a.style.display=d?"":"none";
if(d||a===this.element)if(b=a.childNodes.length)for(e=0;e<b;e+=1)i=a.childNodes[e],3===i.nodeType?(g=a.ellipsisData[e].spaces,h=a.ellipsisData[e].original,c=g.length,i.data=!f?"":!c||c+1<=f?h:h.substr(0,g[f-1]||0),f-=Math.min(f,c+1)):1===i.nodeType&&(f-=f-this.setWordCount(i,f));else f=d-1;return f},computeData:function(a){var d,b,h,g,c,e,i,f=a.ellipsisData=[],j=a.childNodes,k=0;for(a=0,d=j.length;a<d;a+=1)if(b=j[a],3===b.nodeType){f[a]={original:e=b.data,spaces:c=e.match(this.options.spaces)||[]};
for(b=0,h=c.length;b<h;b+=1)i=e.indexOf(c[b],b?i+g:0),g=c[b].length,c[b]=i;c[h-1]+g===e.length&&c.pop();0===c[0]&&c.shift();k+=c.length+1}else 1===b.nodeType&&(k+=this.computeData(b));return k}});return l.Controls.Ellipsis=n})})(window,define);
