/*
 This file is part of Universal Web App (UWA) JavaScript Runtime v1.3

 Copyright(C) 2006-2011 Netvibes
 http://www.netvibes.com

 About: License

 Copyright (c) 2011, Netvibes and/or its affiliates. All rights reserved.
 NETVIBES PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:

 - Redistributions of source code must retain the above copyright
 notice, this list of conditions and the following disclaimer.

 - Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.

 - Neither the name of Netvibes nor the names of its
 contributors may be used to endorse or promote products derived
 from this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
(function(v,u,x){var q=v.document;u("UWA/Controls/Scroller",["UWA/Core","UWA/Controls/Abstract","UWA/Utils/Client","UWA/Fx"],function(i,w,l,r){var o=l.Features,p=l.Platform,u=5.1<=l.Engine.version&&!!p.ios,s=w.extend({debugMode:!1,scrolling:!1,moved:!1,stoped:!1,pulled:!1,enabled:!0,eventNames:{},defaultOptions:{className:"uwa-scroller",body:q.body,width:!1,height:!1,bounce:!1,momentum:!1,snap:!1,threshold:6,lockDirection:!0,scrollbarH:!0,scrollbarV:!0,scrollTime:300,scrollSize:40,scrollDrag:o.dragAndDrop&&
!p.blackberry,useTransform:o.cssTransitions&&!p.webos,useNative:p.blackberry,isTouch:o.touch,has3d:o.cssMatrix},init:function(a,b){this._parent(b);b=this.options;i.extend(this,{position:{x:0,y:0},direction:{x:0,y:0},scroll:{x:!1,y:!1,width:0,height:0},maxScroll:{x:0,y:0},scroller:{width:0,height:0},page:{x:0,y:0},maxPage:{x:0,y:0},scrollMove:{time:0,x:0,y:0},scrollStart:{time:0,x:0,y:0},scrollBars:{x:null,y:null}});b.useNative?this.buildNative(a):this.buildSkeleton(a);this.initEvents();this.setPosition(0,
0,0,!0)},setOptions:function(a){this._parent(a);var a=this.options,b=a.snap;a.snap=!0===b?{x:null,y:null}:"number"===typeof b?{x:b,y:b}:b;return this},buildNative:function(a){var b=this.options,d=this.elements={element:a,scroller:i.createElement("div",{"class":b.className,styles:{overflowScrolling:"touch",overflow:p.blackberry||u?"scroll":"auto",position:"relative",height:b.height||"100%",width:b.width||"100%",userSelect:"none",zoom:"1"}}),wrapper:i.createElement("div",{"class":b.className+"-wrapper"}),
ghost:i.createElement("div",{styles:{height:"10px",width:"10px",background:"#000",position:"absolute","z-index":"1"},events:{click:function(a){i.Event.stop(a);return!1}}})};this.body=b.body||d.scroller;d.scroller.inject(a,"before");d.wrapper.inject(d.scroller);d.ghost.inject(d.scroller);a.inject(d.wrapper);d.scrollerParent=d.scroller.getParent();this.onRefresh()},buildSkeleton:function(a){var b=this.options,d=this.scrollBars,c=this.elements={element:a,scroller:i.createElement("div",{"class":b.className,
styles:{overflow:"hidden",position:"relative",userSelect:"none",zoom:"1"}}),wrapper:i.createElement("div",{"class":b.className+"-wrapper",styles:{width:"100%",height:"100%"}}),ghost:i.createElement("div",{styles:{height:"10px",width:"10px",background:"#000",position:"absolute","z-index":"1",opacity:0},events:{click:function(a){i.Event.stop(a);return!1}}})};this.body=b.body||l.Engine.ie?q.body:v;c.scroller.inject(a,"before");c.wrapper.inject(c.scroller);c.ghost.inject(c.scroller);a.inject(c.wrapper);
c.scrollerParent=c.scroller.getParent();d.x=b.scrollbarH&&new s.Scrollbar(i.extend({dir:"horizontal"},b.scrollbar),this);d.y=b.scrollbarV&&new s.Scrollbar(i.extend({dir:"vertical"},b.scrollbar),this);b.useTransform&&(c.wrapper.setStyles({transformOrigin:"0 0",transitionProperty:c.wrapper.getStyleName("transform",!0).join(","),transform:"translateZ(0)",fontSmoothing:"antialiased"}),b.has3d&&c.wrapper.setStyles({perspective:800,transformStyle:"preserve-3d"}));this.onRefresh()},initEvents:function(){var a,
b,d,c=i.Element.addEvent;b=this.options;d=b.isTouch;var e=this.elements;a=this.eventHandler=this.handleEvent.bindAsEventListener(this);b.useNative||(c.apply(q,["keydown",a]),e.scroller.addEvent("mousewheel",a));if(b.scrollDrag)b=this.eventNames={start:d?"touchstart":"mousedown",move:d?"touchmove":"mousemove",stop:d?"touchend":"mouseup",cancel:d?"touchcancel":"mouseup"},d=this.bodyEvents={},d[b.move]=a,d[b.stop]=a,d[b.cancel]=a,e.scroller.addEvent(b.start,a),c.apply(e.scroller,[b.move,function(a){i.Event.preventDefault(a)}]);
e.element.addEvent("resize",a);e.scrollerParent.addEvent("resize",a)},destroy:function(){var a=i.Element.removeEvent,b=this.elements,d=b.element,c=b.scroller,e=b.wrapper,f=b.scrollerParent,g=this.eventHandler;d&&(d.removeEvent("resize",g),d.inject(b.scroller,"before"));f&&f.removeEvent("resize",g);a.apply(q,["keydown",g]);c.destroy();e.destroy()},handleEvent:function(a){var b,d=this.eventNames;switch(a.type){case d.start:b=this.dispatchEvent("onScrollInit",[a]);break;case d.move:b=this.dispatchEvent("onScrollMove",
[a]);break;case d.cancel:case d.stop:b=this.dispatchEvent("onScrollStop",[a]);break;case "DOMMouseScroll":case "onmousewheel":case "mousewheel":b=this.dispatchEvent("onMouseWheel",[a]);break;case "keydown":b=this.dispatchEvent("onKeyDown",[a]);break;case "transitionend":case "webkitTransitionEnd":case "oTransitionEnd":b=this.dispatchEvent("onScrollEnd",[a]);break;case "DOMSubtreeModified":case "orientationchange":case "resize":b=this.dispatchEvent("onRefresh",[a])}return b},scrollToPage:function(a,
b,d){var c=this.page,e=this.position,f=this.getSnapSize();if(!this.options.snap)c.x=-Math.round(e.x/f.x),c.y=-Math.round(e.y/f.y);"next"===a?a=++c.x:"prev"===a&&(a=--c.x);"next"===b?b=++c.y:"prev"===b&&(b=--c.y);a=!1!==a?-a*f.x:e.x;b=!1!==b?-b*f.y:e.y;f=this.snap(a,b,e);a=f.x;b=f.y;d=Math.max(f.time,!isNaN(d)?d:this.options.scrollTime);this.setPosition(a,b,d)},isInViewport:function(a,b){var d=this.elements.wrapper,c=this.scroll,e=this.getPosition(),f=a.getPosition(d),d=f.y+e.y,e=f.x+e.x,f=a.offsetWidth,
g=a.offsetHeight;return b?d<c.height&&e<c.width&&0<d+g&&0<e+f:0<=d&&0<=e&&d+g<=c.height&&e+f<=c.width},scrollToElement:function(a,b,d){a=i.extendElement(a);"string"===typeof b?b={x:b,y:b}:b===x&&(b={x:"center",y:"center"});for(var c,e,f,g=this.scroll,h=this.maxScroll,j=a.getPosition(),k=a.getDimensions(),n=this.getSnapSize(),t={x:g.width,y:g.height},m={},k={x:k.outerWidth,y:k.outerHeight},a=0;2>a;a+=1)c=a?"x":"y",g[c]?(e=-j[c],"center"===b[c]?e+=(t[c]-k[c])/2:"end"===b[c]&&(e+=t[c]-k[c])):e=0,f=e<
h[c],e=0<e?0:f?h[c]:e,!f&&this.options.snap&&(e=Math[a?"floor":"round"](e/n[c])*n[c]),e<h[c]&&(e=h[c]),m[c]=e;(this.position.x!==m.x||this.position.y!==m.y)&&this.setPosition(m.x,m.y,d)},scrollTo:function(a,b,d){var c,e=this.options,f=this.position,d=!isNaN(d)?d:e.scrollTime;if(e.momentum)c=this.momentum({x:a,y:b},f,d),a=c.x,b=c.y,d=Math.max(c.time,d);if(e.snap)c=this.snap(a,b,f),a=c.x,b=c.y,d=Math.max(c.time,d);(f.x!==a||f.y!==b)&&this.setPosition(a,b,d)},bounce:function(a,b,d){if(0<=a||a<d)a=0<=
a||0<=d?0:d;return a},momentum:function(a,b,d){for(var c,e,f,g,h,j,i,n=this.scroll,t=this.scroller,m={x:0,y:0},l={x:+a.x,y:+a.y,time:d},o={x:a.x-b.x,y:a.y-b.y},b=0;2>b;b++)c=b?"x":"y",e=b?"width":"height",n[c]&&o[c]&&d&&(g=o[c],f=Math.abs(g)/d,j=f*f/0.001,h=n[e],i=-a[c],e=t[e]-n[e]+a[c],0<g&&j>i?(h/=6/(5.0E-4*(j/f)),i+=h,f=f*i/j,j=i):0>g&&j>e&&(h/=6/(5.0E-4*(j/f)),e+=h,f=f*e/j,j=e),l[c]=a[c]+j*(0>g?-1:1),m[c]=f/5.0E-4);n=Math.max(Math.max(m.y,m.x),1);l.time=n>>0;a.time=d;return l},snap:function(a,
b,d){for(var c,e=this.page,f=this.getSnapSize(),g=this.maxScroll,h={x:0<d.x-a?-1:1,y:0<d.y-b?-1:1},i={x:a,y:b},b=0;2>b;b++)c=b?"x":"y",i[c]!==d[c]&&(a=Math[0>h[c]?"floor":h[c]?"ceil":"round"](i[c]/f[c]),e[c]=-a,a*=f[c],isNaN(a)||0<a?a=e[c]=0:a<g[c]&&(e[c]=this.maxPage[c],a=g[c]),i[c]=a);i.time=Math.round(Math.max(500*(Math.abs(d.x-i.x)/f.x),500*(Math.abs(d.y-i.y)/f.y)));return i},getSnapSize:function(){var a=this.options.snap,b=this.scroll;return{x:a&&a.x||b.width,y:a&&a.y||b.height}},getScrollSize:function(){var a=
this.options,b=a.snap;return{x:b&&b.x||a.scrollSize,y:b&&b.y||a.scrollSize}},getPosition:function(){var a,b=this.position,b=this.options;a=this.elements;if(b.useNative)b={y:-a.scroller.scrollTop,x:-a.scroller.scrollLeft};else if(b.useTransform){if(b={y:0,x:0},(a=a.wrapper.getStyle("transform",!0))&&"none"!==a)if(o.cssMatrix)try{a=new WebKitCSSMatrix(a),b={y:a.f,x:a.e}}catch(d){}else a=a.replace(/[^0-9-.,]/g,"").split(","),b={y:+a[5],x:+a[4]}}else b={y:parseInt(a.wrapper.getStyle("top",!0),10),x:parseInt(a.wrapper.getStyle("left",
!0),10)};return{x:b.x>>0,y:b.y>>0}},setPosition:function(a,b,d,c,e){var f,g;f=this.options;var h=this.scrollBars,i=this.scroll;g=this.maxScroll;var k=this.position,d=!isNaN(d)?d:f.scrollTime,a=a>>0,b=b>>0;f.bounce||(a=this.bounce(a,k.x,g.x),b=this.bounce(b,k.y,g.y));f=k.x-a;g=k.y-b;this.position={y:b,x:a};this.direction={x:0<f?-1:1,y:0<g?-1:1};0!==f||0!==g?(this.scrollToPosition(this.position,k,d),h.x&&0!==f&&i.x&&h.x.setPosition(a,d,c),h.y&&0!==g&&i.y&&h.y.setPosition(b,d,c),!this.pulled&&(this.isMaxPosition("x")&&
i.x&&0!==f||this.isMaxPosition("y")&&i.y&&0!==g)&&this.dispatchEvent("onScrollPull")):e&&!this.moved&&this.dispatchEvent("onScrollEnd")},scrollToPosition:function(a,b,d){var c=this,e=c.elements,f=e.scroller,e=e.wrapper,g=c.options,h=function(){c.moved||c.dispatchEvent("onScrollEnd")};c.scrolling||c.dispatchEvent("onScrollStart");a={x:a.x,y:a.y};if(g.useNative)f.scrollTop=-a.y,f.scrollLeft=-a.x,h();else if(g.useTransform)!c.moved&&0<d&&e.addEvent("transitionEnd",c.eventHandler),e.setStyles({transitionTimingFunction:"cubic-bezier(0.33, 0.66, 0.66, 1)",
transitionDuration:d+"ms"}),g.has3d?e.setStyle("transform","translate3d("+a.x+"px,"+a.y+"px, 0)"):e.setStyle("transform","translate("+a.x+"px,"+a.y+"px)"),!c.moved&&0===d&&h();else{if(!c.fx)c.fx=new r(e,{wait:!1});c.fx.options.onComplete=h;c.fx.options.transition=r.Transitions.cubicOut;c.fx.options.duration=d;c.fx.start({top:[b.y,a.y],left:[b.x,a.x]})}},getResetPosition:function(){var a=this.scroll,b=this.getPosition(),d=this.maxScroll,c=b.x,e=b.y;if(0<=b.x||!a.x)c=0;else if(b.x<d.x)c=d.x;if(0<b.y||
!a.y)e=0;else if(b.y<d.y)e=d.y;return{x:c,y:e}},isMaxPosition:function(a,b,d){var b=b||this.position,d=d||this.direction[a],c=this.maxScroll;return 0<d?0<=b[a]:b[a]<=c[a]},onScrollInit:function(a){var b=this.options,d=this.position,c=this.getPosition(),e=i.Event.getElement(a),f=i.Event.getPosition(a),g=Date.now(),h=e&&e.tagName&&-1!==["INPUT","SELECT","TEXTAREA"].indexOf(e.tagName.toUpperCase()),j=this.scroll;if(!this.moved&&this.enabled&&!h&&(this.options.bounce||j.x||j.y))if((this.pulled||this.scrolling)&&
this.updateGhostPosition(f),i.Event.stopPropagation(a),b.isTouch||i.Event.preventDefault(a),i.Element.addEvents.call(this.body,this.bodyEvents),this.threshold={x:0,y:0},this.dist={x:0,y:0},this.startTarget=e,this.scrollStart={time:g,x:c.x,y:c.y},this.scrollMove={time:0,x:f.x,y:f.y},!b.useNative&&b.momentum&&!this.moved&&(this.pulled||c.x!==d.x||c.y!==d.y))b.useTransform&&this.elements.wrapper.removeEvent("transitionEnd",this.eventHandler),i.Event.preventDefault(a),this.stoped=!0,this.scrolling=this.moved=
!1,this.setPosition(c.x,c.y,0,!1,!0)},onScrollMove:function(a){var b=this.options,d=b.threshold,c=this.threshold,e=this.dist,f=this.position,g=this.scroll,h=this.scrollMove,j=i.Event.getPosition(a);i.Event.getElement(a);var k=Date.now(),n=j.x-h.x,h=j.y-h.y,l=f.x+n,m=f.y+h;e.x+=n;e.y+=h;c.x=Math.abs(e.x);c.y=Math.abs(e.y);if(c.y>d||c.x>d){this.updateGhostPosition(j);i.Event.stop(a);this.moved=!0;if(b.lockDirection)if(g.x){if(!g.y)m=f.y}else l=f.x;this.setPosition(l,m,0);this.scrollMove={time:k,x:j.x,
y:j.y}}if(300<k-this.scrollStart.time)this.scrollStart={time:k,x:f.x,y:f.y}},onScrollStop:function(a){var b=this.options,d=this.position,c=this.scrollStart,e=i.Event.getPosition(a);i.Event.getElement(a);var f=Date.now()-c.time,g=b.scrollTime,h=d.x,d=d.y;i.Element.removeEvents.call(this.body,this.bodyEvents);if(this.moved||this.stoped){this.updateGhostPosition(e);i.Event.stop(a);this.stoped=this.moved=!1;if(!b.useNative&&(b.snap||300>f)&&b.momentum)a=this.momentum({y:d,x:h},c,f),h=a.x,d=a.y,g=Math.max(a.time,
g);this.setPosition(h,d,g,!1,!0)}},onScrollStart:function(){this.scrolling=Date.now()},onScrollEnd:function(){var a,b;a=this.options;var d=this.getPosition(),c=this.scrollBars;this.scrolling=!1;if(!this.moved){a.useTransform&&this.elements.wrapper.removeEvent("transitionEnd",this.eventHandler);b=this.getResetPosition();if(this.options.snap)a=this.snap(b.x,b.y,this.scrollStart),b.x=a.x,b.y=a.y;if(d.x!==b.x||d.y!==b.y)this.setPosition(b.x,b.y);else{if(c.x)c.x.onScrollEnd();if(c.y)c.y.onScrollEnd()}this.pulled=
!1}},onScrollPull:function(){this.pulled=!0},updateGhostPosition:function(a){var b=this.elements,d=b.scroller.getPosition(!0);this.options.useNative&&(d.y-=b.scroller.scrollTop,d.x-=b.scroller.scrollLeft);b.ghost.setStyles({top:a.y-d.y-5+"px",left:a.x-d.x-5+"px"})},onKeyDown:function(a){var b=this.position,d=this.scroll,c=this.getScrollSize(),e=a.keyCode,f=b.x,g=b.y,h=38===e,j=37===e,e=40===e||h?"y":39===e||j?"x":!1,h=h||j?1:-1;d[e]&&!this.isMaxPosition(e,b,h)&&(i.Event.stop(a),"x"===e?f+=Math.round(100*
h*c[e])/100:g+=Math.round(100*h*c[e])/100,this.scrollTo(f,g))},onMouseWheel:function(a){var b=this.position,d=this.getScrollSize(),c=b.x,e=b.y,f=this.scroll,f=f.x&&!f.y?"x":"y",g=a.wheel;g&&!this.isMaxPosition(f,b,g)&&(i.Event.stop(a),"x"===f?c+=Math.round(100*g*d[f])/100:e+=Math.round(100*g*d[f])/100,this.scrollTo(c,e))},onRefresh:function(){if(this.elements.scroller.isInjected()){var a,b,d=this.options,c=this.elements,e=this.position,f=this.scrollBars,g=c.element.getScrolls();b=c.scroller.getParent().getDimensions();
a={width:g.width,height:g.height};b={width:d.width||b.innerWidth,height:d.height||b.innerHeight};if(b.width!==this.scroll.width||b.height!==this.scroll.height||a.width!==this.scroller.width||a.height!==this.scroller.height)c.wrapper.setStyles({position:"absolute"}),c.scroller.setStyles({width:b.width+"px",height:b.height+"px"}),b.x=b.width<g.width,b.y=b.height<g.height,this.maxScroll={x:a.width<b.width?0:b.width-a.width,y:a.height<b.height?0:b.height-a.height},this.maxPage={x:Math.ceil(a.width/b.width),
y:Math.ceil(a.height/b.height)},this.scroll=b,this.scroller=a,f.x&&f.x.update(b.width,a.width),f.y&&f.y.update(b.height,a.height),a=this.getResetPosition(),!this.moved&&(a.x!==e.x||a.y!==e.y)&&this.setPosition(a.x,a.y,0,!0),c.scroller.toggleClassName("scrollable",b.y||b.x),c.scroller.toggleClassName("scrollable-x",b.x),c.scroller.toggleClassName("scrollable-y",b.y)}},log:function(a){!0===this.debugMode&&i.log(a)}});s.Scrollbar=w.extend({defaultOptions:{className:"uwa-scrollbar",barColor:"#3E3E3E",
bgColor:!1,opacity:0.7,dir:"vertical",padding:2,width:6,roundCorder:!0,autoHide:!0},position:{x:0,y:0},scroller:null,visible:!0,init:function(a,b){this._parent(a);this.scroller=b;this.visible=!0;this.buildSkeleton();this.options.autoHide&&this.hide()},buildSkeleton:function(){var a,b,d=this.options,c=this.scroller.options,e="horizontal"===d.dir;a=d.padding;var f=d.width,g=d.roundCorder?Math.round(100*(d.width/2)/100):0;b=this.scroller.elements.scroller;this.isHorizontal=e;this.wrapper=b=i.createElement("div",
{"class":d.className+" "+d.className+"-"+d.dir,styles:{"z-index":"10","pointer-events":"none",position:"absolute",overflow:"hidden"}}).inject(b);d.bgColor&&b.setStyle("background",d.bgColor);e?b.setStyles({bottom:a+"px",left:a+"px",height:f+"px"}):b.setStyles({top:a+"px",right:a+"px",width:f+"px"});this.bar=a=i.createElement("div",{styles:{background:d.barColor,opacity:d.opacity,"z-index":"10","pointer-events":"none",position:"absolute",top:0,left:0}}).inject(this.wrapper);7>l.Engine.ie&&a.setHTML("&nbsp;&nbsp;&nbsp;");
e?a.setStyles({borderRadius:g+"px "+g+"px",width:f+"px","min-width":f+1+"px","min-height":f+"px"}):a.setStyles({borderRadius:g+"px "+g+"px",height:f+"px","min-width":f+"px","min-height":f+1+"px"});d.useTransform?(a.setStyles({transformOrigin:"0 0",transitionProperty:a.getStyleName("transform",!0).concat("opacity").join(","),transform:"translateZ(0)"}),c.has3d&&a.setStyles({perspective:800,transformStyle:"preserve-3d"})):this.fx=new r(this.bar,{wait:!1})},update:function(a,b){var d=this.options,c=
this.scroller.scroll,e=this.isHorizontal,f=d.width;this.maxSize=a-2*d.padding-((e?c.y:c.x)?f:0);this.size=Math.min(Math.max(a*a/b>>0,f),this.maxSize);this.maxScroll=this.maxSize-this.size;this.toWrapperProp=this.maxScroll/(a-b);this.wrapper.setStyle(e?"width":"height",this.maxSize+"px");this.bar.setStyle(e?"width":"height",this.size+"px")},setPosition:function(a,b,d){var c=this.bar,e=this.position,f="horizontal"===this.options.dir,g=this.scroller.options,h={y:0,x:0},a=this.toWrapperProp*a>>0;f?h.x=
a:h.y=a;if(h.x!==e.x||h.y!==e.y)!d&&this.options.autoHide&&this.show(),g.useTransform?(c.setStyles({transitionTimingFunction:"cubic-bezier(0.33, 0.66, 0.66, 1)",transitionDelay:"0ms",transitionDuration:(0===b?1:b)+"ms"}),g.has3d?c.setStyle("transform","translate3d("+h.x+"px,"+h.y+"px, 0)"):c.setStyle("transform","translate("+h.x+"px,"+h.y+"px)")):(this.fx.options.transition=r.Transitions.cubicOut,this.fx.options.duration=b,this.fx.start({top:[e.y,h.y],left:[e.x,h.x]}));return this.position=h},onScrollEnd:function(){this.options.autoHide&&
this.hide()},show:function(){var a=this.scroller.options;if(!this.visible)a.useTransform?this.bar.setStyles({transitionDelay:"0ms",transitionDuration:"50ms",opacity:this.options.opacity}):this.bar.show(),this.visible=!0},hide:function(){var a=this.scroller.options;if(this.visible)a.useTransform?this.bar.setStyles({transitionDelay:"300ms",transitionDuration:"150ms",opacity:0}):this.bar.hide(),this.visible=!1},remove:function(){this.wrapper.remove()}});return i.Controls.Scroller=s})})(window,define);
